<html>
<head>
  <meta charset="utf-8">
  <script>

    /*

      Arkanon <arkanon@klsd.org.br>
      2018/10/24 (Wed) 00:31:55 -03
      2018/10/22 (Mon) 00:40:00 -03
      2018/10/21 (Sun) 16:52:03 -03 - v0.4
      2018/10/21 (Sun) 03:03:29 -03
      2018/10/20 (Sat) 21:47:13 -03
      2018/10/19 (Fri) 21:09:26 -03
      2013/07/14 (Sun) 16:22:15 -03 - v0.3
      2013/05/03 (Fri) 04:09:43 -03 - v0.2
      2013/04/19 (Fri) 02:08:11 -03 - v0.1

      <http://news.ycombinator.com/item?id=12168866>
      <http://valera-rozuvan.github.io/FractalViewer>

      TODO
        == interpretar qualquer combinação de parâmetros
        == apresentação na console de estatistiscas da plotagem (data de incio e fim, duração, velocidade média de pontos e linhas, quantidade de pontos por nivel de iteração)
        == salvar na console pontos indicados com o mouse
        == apresentar na console pontos indicados com o mouse
        == aviso sonoro/visual ao finalizar plotagem
        == relacionar número de iterações à posição percentual no gradiente
        ok armazenamento de parãmetros em arquivos de configuração
        ok loop operacional mesmo com a aba em segundo plano
        ok adotar um conceito coerente de zoom
        ok colorização com gradiente
        ok colorização com palette
        ok colorização com função/fórmula
        ok relacionar número de iterações à posição absoluta   no gradiente
        == permitir graus de transparência junto com o gradiente
        == scroll de cores
        == apresentar em labels pontos indicados com o mouse
        == demarcar pontos e áreas com o mouse
        == paralelização da plotagem
        == precisão arbitrária
        == operação simbólica com números complexos
        == plotagem do conjunto de julia associado a pontos selecionados

    */

    var body, marginTop, marginRight, marginBottom, marginLeft;
    var canvas, canvas_id, context, dataset, cor, row, col, N, M, m, Z0, Cr, Ci, ins;
    var winnerW, winnerH, winnerP, canvasW, canvasH, canvasP, planeW, planeH, planeP;
    var viewC, intervW, intervH, cornerBL, cornerTR;
    var gradient, mandelcor, sqmodlim, iteracts, gridstep, zoom;

    function rq (x  ) { return Math.sqrt (x  ) }
    function sen(x  ) { return Math.sin  (x  ) }
    function cos(x  ) { return Math.cos  (x  ) }
    function tg (x  ) { return sen(x)/cos(x  ) }
    function ln (x  ) { return Math.log  (x  ) }
    function abs(x  ) { return Math.abs  (x  ) }
    function pow(x,e) { return Math.pow  (x,e) }
    function int(x,e) { return parseInt  (x  ) }

    const fi = (rq(5)+1)/2;
    const pi = 4*Math.atan(1);

  </script>
  <!--script src="http://unpkg.com/mathjs/dist/math.js"></script-->
  <!--script src="lib/copy_on_axe.js"></script-->
  <script>

    window.onload = function()
    {

      sqmodlim     = 4;
      mandelcor    = [ 0 , 0 , 0 ];
      Z0           = [ 0 , 0 ];

      canvas_id    = 'plano';

      body         = document.getElementsByTagName('body')[0];
      marginTop    = computed('margin-top'   );
      marginRight  = computed('margin-right' );
      marginBottom = computed('margin-bottom');
      marginLeft   = computed('margin-left'  );

     winnerH = window.innerHeight - ( marginTop  + marginBottom );
     winnerW = window.innerWidth  - ( marginLeft + marginRight  );
     winnerP = winnerW/winnerH;


      /*

         DEFAULTS

           cornerBL = [ viewC[0] - gridstep*canvasW/2 , viewC[1] - gridstep*canvasH/2 ]
           cornerTR = [ viewC[0] + gridstep*canvasW/2 , viewC[1] + gridstep*canvasH/2 ]

           gridstep = 2 * Math.sqrt(sqmodlim) / ( canvasW < canvasH ? canvasW : canvasH )
                      ( cornerTR[0] - cornerBL[0] ) / canvasW

         PARAMETROS NECESSARIOS

           canvas.width  = canvasW
           canvas.height = canvasH

           Cr = cornerBL[0] .. cornerTR[0] : + gridstep
           Ci = cornerTR[1] .. cornerBL[1] : - gridstep

      */



   // gridstep = 1;

   // canvasW  = 50;
   // canvasH  = 50;
   // gridstep = 1;

   // canvasW  = 50;
   // canvasH  = 50;
   // gridstep = 1/8;

   // canvasW  = 50;
   // canvasH  = 50;

   // canvasW  = 700;
   // canvasH  = 600;

   // canvasW  = 600;
   // canvasH  = 700;

   // iteracts = 100;
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/400;

   // viewC    = [ -1.45997965 , 0 ];
   // canvasW  = 700;

   // viewC    = [ -1.45997965 , 0 ];
   // canvasH  = 600;

   // viewC    = [ -1.45997965 , 0 ];
   // canvasW  = 700;
   // canvasH  = 600;

   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;

   // iteracts = 100;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/300;

   // iteracts = 100;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/600;

   // iteracts = 500;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/6000;

   // iteracts = 500;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/pow(10,7);

   // iteracts = 1000;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/pow(10,7);

   // iteracts = 5000;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/pow(10,7);

   // iteracts = 5000;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/pow(10,8);

   // iteracts = 10000;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // canvasW  = 700;
   // canvasH  = 600;
   // gridstep = 1/pow(10,8);

   // iteracts = 500;
   // planeW   = 4;
   // planeH   = 4;

   // iteracts = 1000;
   // viewC    = [ -1 , 0 ];
   // planeW   = 0.5;
   // planeH   = 0.5;

   // iteracts = 1000;
   // viewC    = [ -1 , 0 ];
   // planeW   = 0.5;
   // planeH   = 0.7;

   // iteracts = 1000;
   // viewC    = [ -1 , 0 ];
   // planeW   = 0.7;
   // planeH   = 0.5;

   // iteracts = 1000;
   // viewC    = [ -0.5 , 0 ];
   // planeH   = 2.65;
   // planeW   = 3;



   // iteracts = 1000;
   // cornerBL = [ -1.9427 , -0.00115 ];
   // cornerTR = [ -1.9403 ,  0.00115 ];
      // | iteracts : 1000
      // |
      // | winner W : 1280.000000000000000000000000000000000000000000000000000000000000000000000000000000000000
      // | canvas W :  725.000000000000000000000000000000000000000000000000000000000000000000000000000000000000
      // | plane  W :    0.002400000000000179767312147305347025394439697265625000000000000000000000000000000000
      // |
      // | winner H :  695.000000000000000000000000000000000000000000000000000000000000000000000000000000000000
      // | canvas H :  695.000000000000000000000000000000000000000000000000000000000000000000000000000000000000
      // | plane  H :    0.002299999999999999961142194138119521085172891616821289062500000000000000000000000000
      // |
      // | winner P :    1.841726618705036067069613636704161763191223144531250000000000000000000000000000000000
      // | canvas P :    1.043478260869643348129898186016362160444259643554687500000000000000000000000000000000
      // | plane  P :    1.043478260869643348129898186016362160444259643554687500000000000000000000000000000000
      // |
      // | cornerBL : -1.9427 , -0.00115
      // | cornerTR : -1.9403 ,  0.00115
      // |
      // | interv W : undefined
      // | interv H : undefined
      // |
      // | viewC    : -1.9415,0
      // |
      // | gridstep :      0.000003309352517985611821115963723793917949933529598638415336608886718750000000000000
      // | zoom     : 302173.913043478212784975767135620117187500000000000000000000000000000000000000000000000000



      iteracts = 1000;
      viewC    = [ -1.9415 , 0 ];
      zoom     = 302173.913043478212784975767135620117187500000000000000000000000000000000000000000000000000
      // | plane  H :  0.002300000000000000394823063132321294688154011964797973632812500000000000000000000000
      // | winner P :  1.841726618705036067069613636704161763191223144531250000000000000000000000000000000000
      // | canvas P :  1.841726618705036067069613636704161763191223144531250000000000000000000000000000000000
      // | plane  P :  1.841726618705036067069613636704161763191223144531250000000000000000000000000000000000
      // | cornerBL : -1.9436179856115108 , -0.0011500000000000002
      // | cornerTR : -1.9393820143884892 ,  0.0011500000000000002
      // | gridstep :  0.000003309352517985612244632437350944087484094779938459396362304687500000000000000000



// até aqui ok //



   // iteracts = 1000;
   // viewC    = [ -0.74502165 , 0.12440116 ];
   // gridstep = 0.004338394793926247418325292670715498388744890689849853515625;
   // planeW   = 0.00001267829811506426; // gridstep = 0.000000007924; // planeH = 0.0000062916054396006395;

   // iteracts = 1000;
   // intervW  = [ -1.2503 , -0.7497 ];
   // viewC    = [ (intervW[0]+intervW[1])/2 , 0 ];
   // planeW   = intervW[1]-intervW[0];

   /* ----------------------------------------------------------------------------------------------------------

      winnerW   = window.innerWidth  - ( marginLeft + marginRight  )
      winnerH   = window.innerHeight - ( marginTop  + marginBottom )
      winnerP   = winnerW/winnerH

      iteracts  = 50 ------------------------------- def
      iteracts  = free

      canvasW   = winnerW -------------------------- def
                  int(canvasH*planeP)

      canvasH   = winnerH -------------------------- def
                  int(canvasW/planeP)

      canvasP   = canvasW/canvasH ------------------ def

      planeW    = canvasW<canvasH ? 4 : 4*canvasP -- def
                  cornerTR[0]-cornerBL[0]
                  gridstep*canvasW

      planeH    = canvasW>canvasH ? 4 : 4/canvasP -- def
                  cornerTR[1]-cornerBL[1]
                  gridstep*canvasH
                  planeW/canvasP

      planeP    = planeW/planeH -------------------- def

      cornerBL  = [ viewC[0]-planeW/2 , viewC[1]-planeH/2 ]

      cornerTR  = [ viewC[0]+planeW/2 , viewC[1]+planeH/2 ]

      intervW   =

      intervH   =

      viewC     = [0,0] ---------------------------- def

      gridstep  = planeW/canvasW ------------------- def
                  (cornerTR[0]-cornerBL[0])/canvasW
                  1/zoom

      zoom      = canvasW/planeW ------------------- def
                  1/gridstep

      ---------------------------------------------------------------------------------------------------------- */

      if ( iteracts === undefined ) iteracts = 50;

      if ( cornerBL === undefined && cornerTR === undefined )
      {
        if ( viewC    === undefined ) viewC = [ 0 , 0 ];
        if ( gridstep === undefined && zoom === undefined )
        {
          if ( planeW === undefined )
          {
            if ( canvasW === undefined ) canvasW = winnerW;
            if ( canvasH === undefined ) canvasH = winnerH;
            canvasP = canvasW/canvasH;
         // if ( planeH  === undefined ) planeH  = canvasW > canvasH ? 4 : 4 / canvasP
         // planeW = canvasW < canvasH ? 4 : 4 * canvasP;
            if ( planeH  === undefined && canvasP > 1 ) planeH = 4;
            if ( planeH  === undefined && canvasP < 1 ) planeH = 4 / canvasP;
            planeW = planeH * canvasP;
            planeP = planeW/planeH;
          }
          else
          {
            if ( planeH  === undefined )
            {
              if ( canvasW === undefined ) canvasW = winnerW;
              if ( canvasH === undefined ) canvasH = winnerH;
              canvasP = canvasW/canvasH;
              planeH  = planeW/canvasP;
              planeP  = planeW/planeH;
            }
            else
            {
// alert(1);
              planeP = planeW/planeH;
              if ( canvasH === undefined ) canvasH = winnerH;
              if ( canvasW === undefined ) canvasW = canvasH*planeP;
              canvasP = canvasW/canvasH;
              if ( planeH  === undefined ) planeH  = planeW/canvasP;
            }
          }
          cornerBL = [ viewC[0] - planeW/2 , viewC[1] - planeH/2 ];
          cornerTR = [ viewC[0] + planeW/2 , viewC[1] + planeH/2 ];
          gridstep = ( cornerTR[0] - cornerBL[0] ) / canvasW;
        }
        else
        {
          if ( gridstep === undefined ) gridstep = 1/zoom;
          if ( zoom     === undefined ) zoom     = 1/gridstep;
          if ( canvasW  === undefined ) canvasW = winnerW;
          if ( canvasH  === undefined ) canvasH = winnerH;
          canvasP  = canvasW/canvasH;
          planeW   = gridstep * canvasW;
          planeH   = gridstep * canvasH;
          planeP   = planeW/planeH;
          cornerBL = [ viewC[0] - planeW/2 , viewC[1] - planeH/2 ];
          cornerTR = [ viewC[0] + planeW/2 , viewC[1] + planeH/2 ];
        }
      }
      else
      {
        planeW = cornerTR[0] - cornerBL[0];
        planeH = cornerTR[1] - cornerBL[1];
        viewC  = [ (cornerTR[0]+cornerBL[0])/2 , (cornerTR[1]+cornerBL[1])/2 ];
        planeP = planeW/planeH;
        if ( planeP > winnerP )
        {
          if ( canvasH === undefined )
          {
            if ( canvasW === undefined ) canvasW = winnerW;
            canvasH  = canvasW/planeP;
          }
          else
          {
            canvasW  = canvasH*planeP;
          }
        }
        else
        {
          if ( canvasW === undefined )
          {
            if ( canvasH === undefined ) canvasH = winnerH;
            canvasW  = canvasH*planeP;
          }
          else
          {
            canvasH  = canvasW/planeP;
          }
        }
        canvasP  = canvasW/canvasH;
        gridstep = planeW/canvasW;
        zoom     = 1/gridstep;
      }

      canvasW = int(canvasW);
      canvasH = int(canvasH);



/*

      if ( canvasH === undefined )
      {
        if ( cornerBL === undefined && cornerTR === undefined )
        {
          canvasH = winnerH;
        }
        else
        {
          planeW = cornerTR[0] - cornerBL[0];
          planeH = cornerTR[1] - cornerBL[1];
          if ( planeW/planeH > winnerW/winnerH )
          {
            canvasW  = winnerW;
            canvasH  = canvasW*planeH/planeW;
            gridstep = planeH/canvasH;
          }
          else
          {
            canvasH  = winnerH;
            canvasW  = canvasH*planeW/planeH;
            gridstep = planeW/canvasW;
          }
        }
      }

      if ( gridstep === undefined )
      {
        if ( planeW === undefined ) planeW = planeH * canvasW/canvasH;
        if ( planeH === undefined ) planeH = planeW * canvasH/canvasW;
        cornerBL = [ viewC[0] - planeW/2 , viewC[1] - planeH/2 ];
        cornerTR = [ viewC[0] + planeW/2 , viewC[1] + planeH/2 ];
        gridstep = ( cornerTR[0] - cornerBL[0] ) / canvasW;
      }
      else
      {
        planeW   = canvasW < canvasH ? 4 : 4 * canvasW/canvasH;
        planeH   = canvasW > canvasH ? 4 : 4 * canvasH/canvasW;
        cornerBL = [ viewC[0] - gridstep*canvasW/2 , viewC[1] - gridstep*canvasH/2 ]
        cornerTR = [ viewC[0] + gridstep*canvasW/2 , viewC[1] + gridstep*canvasH/2 ]
      }

*/



      var digse = 84
      console.log
      ( ''
        + '\n' + '| iteracts : ' + iteracts
        + '\n' + '|'
        + '\n' + '| winner W : ' + winnerW.toFixed(digse).pad()
        + '\n' + '| canvas W : ' + canvasW.toFixed(digse).pad()
        + '\n' + '| plane  W : ' +  planeW.toFixed(digse).pad()
        + '\n' + '|'
        + '\n' + '| winner H : ' + winnerH.toFixed(digse).pad()
        + '\n' + '| canvas H : ' + canvasH.toFixed(digse).pad()
        + '\n' + '| plane  H : ' +  planeH.toFixed(digse).pad()
        + '\n' + '|'
        + '\n' + '| winner P : ' + winnerP.toFixed(digse).pad()
        + '\n' + '| canvas P : ' + canvasP.toFixed(digse).pad()
        + '\n' + '| plane  P : ' +  planeP.toFixed(digse).pad()
        + '\n' + '|'
        + '\n' + '| cornerBL : ' + cornerBL
        + '\n' + '| cornerTR : ' + cornerTR
        + '\n' + '|'
        + '\n' + '| interv W : ' + intervW
        + '\n' + '| interv H : ' + intervH
        + '\n' + '|'
        + '\n' + '| viewC    : ' + viewC
        + '\n' + '|'
        + '\n' + '| gridstep : ' + gridstep.toFixed(digse).pad()
        + '\n' + '| zoom     : ' +     zoom.toFixed(digse).pad()
      );



      gradient = [
                   [ [ 255, 255, 255 ],     0 ],
                   [ [   1,  15, 170 ],    10 ],
                   [ [  26, 193,  23 ],   500 ],
                   [ [ 240, 244,   2 ],  2000 ],
                   [ [ 117,  34,   1 ],  6000 ],
                   [ [   0,   0,   0 ], 10000 ],
                 ];

      canvas        = document.getElementById(canvas_id);
      canvas.width  = canvasW;
      canvas.height = canvasH;
      context       = canvas.getContext('2d');
      dataset       = context.getImageData(0, 0, canvasW, canvasH);

      row = 0;
      Ci  = cornerTR[1]-1*gridstep;

      mainloop();

    }



    String.prototype.pad = function()
    {
      var s = String(this);
      if ( this <   10 ) { s = ' ' + s }
      if ( this <  100 ) { s = ' ' + s }
      if ( this < 1000 ) { s = ' ' + s }
      return s;
    }



    function mainloop()
    {
      col = 0;
      for ( Cr = cornerBL[0]+1*gridstep; Cr < cornerTR[0]; Cr += gridstep )
      {
        ins = inSet1(Cr, Ci, iteracts, sqmodlim);
          M = Math.sqrt(ins[1]);
          m = Math.sqrt(ins[2]);
          N =           ins[3];

        // <http://stackoverflow.com/a/25816111>
        // Based on <http://jsfiddle.net/vksn3yLL> from <http://stackoverflow.com/a/30144587>
        //  <http://jsfiddle.net/arkanon/vksn3yLL/1328>     interactive
        //  <http://jsfiddle.net/arkanon/vksn3yLL/1316> non-interactive
        var slider        = N;
        var colorRange = [ gradient.length-2, gradient.length-1 ];
        for ( var index in gradient ) if ( slider <= gradient[index][1] ) { colorRange = [ index-1, index ]; break }

        // get the two closest colors
        var firstcolor    = gradient[colorRange[0]][0];
        var secondcolor   = gradient[colorRange[1]][0];

        // calculate ratio between the two closest colors
        var firstcolor_x  = gradient[colorRange[0]][1]/100;
        var secondcolor_x = gradient[colorRange[1]][1]/100 - firstcolor_x;
        var slider_x      = slider/100                     - firstcolor_x;
        var ratio         = slider_x/secondcolor_x;

     //     cor           = ( ins[0] || N==1 ) ? mandelcor : pickHex( secondcolor, firstcolor, ratio );

             if ( N == 1 ) cor = mandelcor // [ 255, 255, 255 ]
        else if ( ins[0] ) cor = mandelcor
        else               cor = pickHex( secondcolor, firstcolor, ratio );

        plotpix(row, col, cor);
        col++;
      }
      Ci -= gridstep;
      row++;
      context.putImageData(dataset, 0, 0);
      if ( Ci > cornerBL[1] ) setZeroTimeout(mainloop);
    }



    function  inSet1(Cr, Ci, iteracts, sqmodlim)
    {
      var tmp, Znr, Zni, Zm2, n;
      Znr = Z0[0];
      Zni = Z0[1];
      for (n=1; n<=iteracts; n++)
      {
        // z²+c <http://maxima.cesga.es>
        tmp = Znr * Zni * 2         + Ci;
        Znr = Znr * Znr - Zni * Zni + Cr;
        Zni = tmp;
        Zm2 = Znr * Znr + Zni * Zni;
        Cm2 = Cr  * Cr  + Ci  * Ci;
        if (Zm2 >= sqmodlim) return [false, Zm2, Cm2, n];
      }
      return [true, Zm2, Cm2];
    }



    function  inSet2(Cr, Ci, iteracts, sqmodlim)
    {

      var C, Zn, Zm2, n;
      C  = math.complex( Cr    , Ci    );
      Zn = math.complex( Z0[0] , Z0[1] );
      for (n=1; n<=iteracts; n++)
      {
        Zn = math.add(math.pow(Zn,2), C);

   //   Zm = math.norm(Zn);
   //   Cm = math.norm(C );
   //   if (Zm >= 2) return [false, Zm, Cm, n];
   // }
   // return [true, Zm, Cm];

        Zm2 = math.pow(math.re(Zn),2) + math.pow(math.im(Zn),2);
        Cm2 = math.pow(math.re(C ),2) + math.pow(math.im(C ),2);
        if (Zm2 >= sqmodlim) return [false, Zm2, Cm2, n];
      }
      return [true, Zm2, Cm2];

    }



    function plotpix(row, col, cor)
    {
      var i = ( row * canvasW + col ) * 4;
      dataset.data[i+0] = cor[0];
      dataset.data[i+1] = cor[1];
      dataset.data[i+2] = cor[2];
      dataset.data[i+3] = 255;
    }



    function pickHex(color1, color2, weight)
    {
      var p   = weight;
      var w   = 2*p - 1;
      var w1  = (w+1)/2;
      var w2  = 1 - w1;
      var rgb = [
                  Math.round( w1*color1[0] + w2*color2[0] ),
                  Math.round( w1*color1[1] + w2*color2[1] ),
                  Math.round( w1*color1[2] + w2*color2[2] ),
                ];
      return rgb;
    }



    function computed(prop)
    {
      return parseFloat(window.getComputedStyle(body).getPropertyValue(prop));
    }



    // setZeroTimeout <http://dbaron.org/log/20100309-faster-timeouts>
    (

      // add only to the window object, and hide everything else in a closure.

      function()
      {

        var timeouts = [];
        var messageName = "zero-timeout-message";

        // Like setTimeout, but only takes a function argument. There's no time argument
        // (always zero) and no arguments (you have to use a closure).
        function setZeroTimeout(fn)
        {
          timeouts.push(fn);
          window.postMessage(messageName, "*");
        }

        function handleMessage(event)
        {
          if (event.source == window && event.data == messageName)
          {
            event.stopPropagation();
            if (timeouts.length > 0)
            {
              var fn = timeouts.shift();
              fn();
            }
          }
        }

        window.addEventListener("message", handleMessage, true);

        // Add the one thing we want added to the window object.
        window.setZeroTimeout = setZeroTimeout;

      }

    )();



  </script>
  <style>
    body   { margin: 0; background: grey; display: table; width: 100%; height: 100%; }
    div    { display: table-cell; vertical-align: middle; }
    canvas { margin: auto; display: block; }
  </style>
</head>
<body><div><canvas id="plano"></canvas></div></body>
</html>
